﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Xml.Linq;
using System.Xml;
using System.Text;
using Windows.Data.Xml.Dom;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using System.Collections;
using Windows.Storage;
using Windows.Storage.Streams;
using Windows.Storage.Pickers;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using Windows.UI.Xaml.Media.Animation;

// The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

namespace StudyTime_1
{
    /// <summary>
    /// A basic page that provides characteristics common to most applications.
    /// </summary>
    public sealed partial class quizBuilder1 : StudyTime_1.Common.LayoutAwarePage
    {

        public List<quizQuest> quizList = new List<quizQuest>();
        private bool saveLocation = false;
        private string filePath;
        private string fileName = "goo.xml";
        private StorageFile storage;

        public quizBuilder1()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
        }

        /// <summary>
        /// Preserves state associated with this page in case the application is suspended or the
        /// page is discarded from the navigation cache.  Values must conform to the serialization
        /// requirements of <see cref="SuspensionManager.SessionState"/>.
        /// </summary>
        /// <param name="pageState">An empty dictionary to be populated with serializable state.</param>
        protected override void SaveState(Dictionary<String, Object> pageState)
        {
        }

        async public void selection()
        {

            FileSavePicker savePicker = new FileSavePicker();
            savePicker.SuggestedStartLocation = PickerLocationId.Downloads;
            savePicker.SuggestedFileName = "quiz1";
            savePicker.DefaultFileExtension = ".quizxml";
            savePicker.FileTypeChoices.Add("QUIZ", new List<string>() { ".quizxml" });
            storage = await savePicker.PickSaveFileAsync();

            if (null != storage)
            {
                // Application now has read/write access to the picked file
                filePath = storage.Path;
                fileName = storage.Name;
                saveLocation = true;
                SerializeXML(quizList);

            }
            else
            {
                errorBox.Text = "File was not returned";
            }
        }

        async private void SerializeXML(List<quizQuest> convert)
        {

            try
            {
                var file = await storage.OpenAsync(FileAccessMode.ReadWrite);
                Stream outStream = file.AsStreamForWrite();



                DataContractSerializer xml = new DataContractSerializer(typeof(List<quizQuest>));


                xml.WriteObject(outStream, convert);

                errorBox.Text = "Saved Successfully!";
            }
            catch (IOException)
            {
                errorBox.Text = "Cannot write to the file";
            }

        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            quizQuest quest = new quizQuest();
            quest.question = multQuest.Text.ToString();
            quest.answerA = answerA.Text.ToString();
            quest.answerB = answerB.Text.ToString();
            quest.answerC = answerB.Text.ToString();
            quest.answerD = answerD.Text.ToString();
            quest.answer = finalAnswer.Text.ToString();

            quizList.Add(quest);

            errorBox.Text = quizList.Count.ToString() + " " + "Items Added";
            answerA.Text = "";
            answerB.Text = "";
            answerC.Text = "";
            answerD.Text = "";
            finalAnswer.Text = "";
            multQuest.Text = "";

            saveAll.IsEnabled = true;


        }



        private void saveAll_Click(object sender, RoutedEventArgs e)
        {
            if (saveLocation == false)
            {

                selection();
            }

            else
            {
                SerializeXML(quizList);
            }




        }

        private void back_Click(object sender, RoutedEventArgs e)
        {
            this.Frame.GoBack();
        }

        private void pageRoot_Loaded(object sender, RoutedEventArgs e)
        {
            saveAll.IsEnabled = false;

            Storyboard sb = this.FindName("quizBuilderStory") as Storyboard;
            if (sb != null)
            {
                sb.Begin();
            }
        }



    }
}
